<template>
  <canvas-source-3-d
    v-if="source.type === '3d'"
    :source="source"
    @image-mouseover="$emit('image-mouseover')"
  />
  <canvas-source-grid
    v-else-if="source.type === 'grid'"
    :source="source"
    :signature="signature"
  />
  <canvas-source-score
    v-else
    :source="source"
    @image-mouseover="$emit('image-mouseover')"
  />
</template>

<script lang="ts">
import type { Signature, Source } from '@/data';
import { Component, Prop, Vue } from 'vue-property-decorator';
import CanvasSource3D from './CanvasSource3D.vue';
import CanvasSourceGrid from './CanvasSourceGrid.vue';
import CanvasSourceScore from './CanvasSourceScore.vue';

@Component({
  components: {
    CanvasSource3D,
    CanvasSourceScore,
    CanvasSourceGrid,
  },
})
export default class CanvasSourceBase extends Vue {
  @Prop({ required: true })
  source!: Source;

  @Prop({ required: false })
  signature!: Signature;
}
</script>
